/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#define CN	(char*) 0

#define U_MAX(a,b)	(((a)>(b))?a:b)
#define U_MIN(a,b)	(((a)>(b))?b:a)

#ifndef TURBO_C

#define U_DEFINE_STACK(array,Type,size)	\
Type *array;\
int array/**/_top = 0, array/**/_size = 0;\
\
Type U_stack_push_/**/array (element)\
Type element;\
{\
	Type *array/**/_new;\
	int i;\
	if (array/**/_top >= array/**/_size) {\
		array/**/_size = array/**/_size + size;\
		array/**/_new = (Type*) U_malloc (sizeof (Type) * array/**/_size);\
		for (i = 0; i < array/**/_size - size; i++)\
			array/**/_new[i] = array[i];\
		U_free (array);\
		array = array/**/_new;\
	}\
	array[array/**/_top++] = element;\
	return element;\
}\
Type U_stack_pop_/**/array ()\
{\
	if (array/**/_top > 0)\
		return array[--(array/**/_top)];\
	else\
		return (Type) 0;\
}\
U_stack_clear_/**/array ()\
{\
	U_free (array);\
	array = (Type*) 0;\
	array/**/_top = 0;\
	array/**/_size = 0;\
}

#define UNEW_DEFINE_STACK_TYPE(array,Type,siz,Stack)\
typedef struct Stack {\
	Type *stack;\
	int top, size;\
	PtF push, pop, clear;\
} Stack;\
extern Stack *array;

#define UNEW_DEFINE_STACK(array,Type,siz,Stack)\
Stack *array=(Stack*)0;\
U_stack_pop_/**/array()\
{\
	--array->top;\
}\
U_stack_clear_/**/array()\
{\
	U_free(array->stack);\
	U_free(array);\
	array=(Stack*)0;\
}\
U_stack_push_/**/array(ele)\
Type ele;\
{\
	Stack *new;\
	int i;\
	if(array==(Stack*)0) {\
		array=(Stack*)U_malloc(sizeof(Stack));\
		array->top=array->size=0;\
	}\
	if(array->top>=array->size){\
		new=(Stack*)U_malloc(sizeof(Stack));\
		new->top=array->top;\
		new->size=array->size+siz;\
		array->push=U_stack_push_/**/array;\
		array->pop=U_stack_pop_/**/array;\
		array->clear=U_stack_clear_/**/array;\
		new->stack=(Type*)U_malloc(sizeof(Type)*new->size);\
		for(i=0;i<new->size-siz;i++)\
			new->stack[i]=array->stack[i];\
		U_free(array->stack);\
		U_free(array);\
		array=new;\
	}\
	array->stack[array->top++]=ele;\
}

#else

#define U_DEFINE_STACK(array,Type,size)	\
Type *array;\
int array##_top = 0, array##_size = 0;\
\
Type U_stack_push_##array (element)\
Type element;\
{\
	Type *array##_new;\
	int i;\
	if (array##_top >= array##_size) {\
		array##_size = array##_size + size;\
		array##_new = (Type*) U_malloc (sizeof (Type) * array##_size);\
		for (i = 0; i < array##_size - size; i++)\
			array##_new[i] = array[i];\
		U_free (array);\
		array = array##_new;\
	}\
	array[array##_top++] = element;\
	return element;\
}\
Type U_stack_pop_##array ()\
{\
	if (array##_top > 0)\
		return array[--(array##_top)];\
	else\
		return (Type) 0;\
}\
U_stack_clear_##array ()\
{\
	U_free (array);\
	array = (Type*) 0;\
	array##_top = 0;\
	array##_size = 0;\
}

#define UNEW_DEFINE_STACK_TYPE(array,Type,siz,Stack)\
typedef struct Stack {\
	Type *stack;\
	int top, size;\
	PtF push, pop, clear;\
} Stack;\
extern Stack *array;

#define UNEW_DEFINE_STACK(array,Type,siz,Stack)\
Stack *array=(Stack*)0;\
U_stack_pop_##array()\
{\
	--array->top;\
}\
U_stack_clear_##array()\
{\
	U_free(array->stack);\
	U_free(array);\
	array=(Stack*)0;\
}\
U_stack_push_##array(ele)\
Type ele;\
{\
	Stack *new;\
	int i;\
	if(array==(Stack*)0) {\
		array=(Stack*)U_malloc(sizeof(Stack));\
		array->top=array->size=0;\
	}\
	if(array->top>=array->size){\
		new=(Stack*)U_malloc(sizeof(Stack));\
		new->top=array->top;\
		new->size=array->size+siz;\
		array->push=U_stack_push_##array;\
		array->pop=U_stack_pop_##array;\
		array->clear=U_stack_clear_##array;\
		new->stack=(Type*)U_malloc(sizeof(Type)*new->size);\
		for(i=0;i<new->size-siz;i++)\
			new->stack[i]=array->stack[i];\
		U_free(array->stack);\
		U_free(array);\
		array=new;\
	}\
	array->stack[array->top++]=ele;\
}

#endif
